/* Parallel Hierarchical Grid -- an adaptive finite element library.
 *
 * Copyright (C) 2005-2007 State Key Laboratory of Scientific and
 * Engineering Computing, Chinese Academy of Sciences. */

/* This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA */

/* $Id: solver-phg.h,v 1.4 2007/05/19 16:00:43 tcui Exp $ */

#ifndef PHG_SOLVER_PCG_H
#define PHG_SOLVER_PCG_H

#define phgSolverPCG(A,b,x_ptr,pc,maxits,rtol,res) \
	    phgSolverPCG__(A,b,x_ptr,pc,maxits,rtol,1.0e-20,res) 
#define phgSolverGMRES(A,b,x_ptr,pc,maxits,rtol,res) \
	    phgSolverGMRES__(A,b,x_ptr,pc,maxits,rtol,1.0e-20,res) 
		
#ifdef __cplusplus
extern "C" {
#endif
    int phgSolverJacobi(MAT *A, VEC *b, VEC **x, 
                                     int max_its, FLOAT rtol,FLOAT *res);
    int phgSolverPCG__(MAT *A, VEC *b, VEC **x_ptr,
                SOLVER_PC *pc, int max_its, FLOAT rtol, FLOAT atol, FLOAT *res);
    int phgSolverGMRES__(MAT *A, VEC *b, VEC **x_ptr,
                SOLVER_PC *pc, int max_its, FLOAT rtol, FLOAT atol, FLOAT *res);
    void phgSolverGMRESRestartSteps(int Steps);
#ifdef __cplusplus
}
#endif
#endif
